;; -*- coding: utf-8 -*-
;; (find-es "emacs" "Help:IPA")
;; http://www.personal.rdg.ac.uk/~llsroach/encyc.pdf
;; (load (buffer-file-name))

(setq help-ipa-plist
      '("a"  "Open front unrounded vowel"
	"aː" "Open front unrounded vowel" 
	"ɑ"  "Open back unrounded vowel" 
	"ɑː" "Open back unrounded vowel" 
	"ɒ"  "Open back rounded vowel" 
	"ʌ"  "Open-mid back unrounded vowel" 
	"æ"  "Near-open front unrounded vowel" 
	"b"  "Voiced bilabial plosive" 
	"ɓ"  "Voiced bilabial implosive" 
	"ʙ"  "Bilabial trill" 
	"β"  "Voiced bilabial fricative" 
	"c"  "Voiceless palatal plosive" 
	"ç"  "Voiceless palatal fricative" 
	"ɕ"  "Voiceless alveolo-palatal fricative" 
	"ɔ"  "Open-mid back rounded vowel" 
	"d"  "Voiced alveolar plosive" 
	"ɗ"  "Voiced alveolar implosive" 
	"ɖ"  "Voiced retroflex plosive" 
	"ð"  "Voiced dental fricative" 
	"dz" "Voiced alveolar affricate"
	"dʒ" "Voiced postalveolar affricate"
	"e"  "Close-mid front unrounded vowel" 
	"eː" "Close-mid front unrounded vowel" 
	"ə"  "Mid central vowel" 
	"ɛ"  "Open-mid front unrounded vowel" 
	"ɜ"  "Open-mid central unrounded vowel" 
	"f"  "Voiceless labiodental fricative" 
	"ɟ"  "Voiced palatal plosive" 
	"ʄ"  "Voiced palatal implosive" 
	"ɡ"  "Voiced velar plosive" 
	"ɠ"  "Voiced velar implosive" 
	"ɢ"  "Voiced uvular plosive" 
	"ʒ"  "Voiced postalveolar fricative" 
	"h"  "Voiceless glottal fricative" 
	"ɦ"  "Voiced glottal fricative" 
	"ħ"  "Voiceless pharyngeal fricative" 
	"ɥ"  "Labial-palatal approximant" 
	"i"  "Close front unrounded vowel" 
	"iː" "Close front unrounded vowel" 
	"ɪ"  "Near-close near-front unrounded vowel" 
	"ɨ"  "Close central unrounded vowel" 
	"j"  "Palatal approximant" 
	"ʝ"  "Voiced palatal fricative" 
	"ɟ"  "Voiced palatal plosive" 
	"ʄ"  "Voiced palatal implosive" 
	"k"  "Voiceless velar plosive" 
	"l"  "Alveolar lateral approximant" 
	"ɫ"  "Velarized alveolar lateral approximant" 
	"ɬ"  "Voiceless alveolar lateral fricative" 
	"ɭ"  "Retroflex lateral approximant" 
	"ɺ"  "Alveolar lateral flap" 
	"ɮ"  "Voiced alveolar lateral fricative" 
	"m"  "Bilabial nasal" 
	"ɱ"  "Labiodental nasal" 
	"ʍ"  "Voiceless labio-velar fricative" 
	"n"  "Alveolar nasal" 
	"ŋ"  "Velar nasal" 
	"ɲ"  "Palatal nasal" 
	"ɳ"  "Retroflex nasal" 
	"ɴ"  "Uvular nasal" 
	"o"  "Close-mid back rounded vowel" 
	"oː" "Close-mid back rounded vowel" 
	"ɔ"  "Open-mid back rounded vowel" 
	"ɔː" "Open-mid back rounded vowel" 
	"ø"  "Close-mid front rounded vowel" 
	"øː" "Close-mid front rounded vowel" 
	"œ"  "Open-mid front rounded vowel" 
	"œː" "Open-mid front rounded vowel" 
	"θ"  "Voiceless dental fricative" 
	"ɸ"  "Voiceless bilabial fricative" 
	"p"  "Voiceless bilabial plosive" 
	"q"  "Voiceless uvular plosive" 
	"r"  "Alveolar trill" 
	"ɾ"  "Alveolar tap" 
	"ʀ"  "Uvular trill" 
	"ɽ"  "Retroflex flap" 
	"ɹ"  "Alveolar approximant" 
	"ɻ"  "Retroflex approximant" 
	"ʁ"  "Voiced uvular fricative" 
	"s"  "Voiceless alveolar fricative" 
	"ʃ"  "Voiceless postalveolar fricative" 
	"ʂ"  "Voiceless retroflex fricative" 
	"t"  "Voiceless alveolar plosive" 
	"ʈ"  "Voiceless retroflex plosive" 
	"ts" "Voiceless alveolar affricate"
	"u"  "Close back rounded vowel" 
	"uː" "Close back rounded vowel" 
	"ʊ"  "Near-close near-back rounded vowel" 
	"ʉ"  "Close central rounded vowel" 
	"ɥ"  "Labial-palatal approximant" 
	"ɯ"  "Close back unrounded vowel" 
	"v"  "Voiced labiodental fricative" 
	"ʋ"  "Labiodental approximant" 
	"ɣ"  "Voiced velar fricative" 
	"ɤ"  "Close-mid back unrounded vowel" 
	"w"  "Voiced labio-velar approximant" 
	"ʍ"  "Voiceless labio-velar fricative" 
	"ɯ"  "Close back unrounded vowel" 
	"ɰ"  "Voiced velar approximant" 
	"x"  "Voiceless velar fricative" 
	"χ"  "Voiceless uvular fricative" 
	"y"  "Close front rounded vowel" 
	"yː" "Close front rounded vowel" 
	"ʏ"  "Near-close near-front rounded vowel" 
	"ʎ"  "Palatal lateral approximant" 
	"ɥ"  "Labial-palatal approximant" 
	"ɤ"  "Close-mid back unrounded vowel" 
	"z"  "Voiced alveolar fricative" 
	"ʒ"  "Voiced postalveolar fricative" 
	"ʑ"  "Voiced alveolo-palatal fricative" 
	"ʐ"  "Voiced retroflex fricative" 
	"ʔ"  "Glottal stop" 
	"ʕ"  "Voiced pharyngeal fricative" 
	"ǀ"  "Dental click" 
	"ǁ"  "Alveolar lateral click" 
	"ǃ"  "Postalveolar click"
	))

(defun help-ipa-foo (str)
  (let* ((long (lax-plist-get help-ipa-plist str))
	 (long_ (replace-regexp-in-string " " "_" long))
	 (soundfile (format "~/usrc/help-ipa/%s.ogg" long_)))
    (find-bgprocess (list "ogg123" "-q" soundfile))
    long))

;; (help-ipa-foo "y")
;; (help-ipa-foo "z")
;; (help-ipa-foo "e")
;; (help-ipa-foo "a")
;; (help-ipa-foo "dz")
;; (help-ipa-foo "dʒ")
;; (find-man "ogg123")

(defun help-ipa-pron (str)
  (interactive (list (word-at-point)))
  (message (format "%s - %s" str (help-ipa-foo str))))

(defalias 'p 'help-ipa-pron)

;; a ɑ ɒ ʌ æ b ɓ ʙ β c ç ɕ ɔ d ɗ ɖ ð dz dʒ
;; e ə ɛ ɜ f ɟ ʄ ɡ ɠ ɢ ʒ h ɦ ħ ɥ
;; i ɪ ɨ j ʝ ɟ ʄ k l ɫ ɬ ɭ ɺ ɮ m ɱ ʍ n ŋ ɲ ɳ ɴ
;; o ɔ ø œ θ ɸ p q r ɾ ʀ ɽ ɹ ɻ ʁ s ʃ ʂ t ʈ ts
;; u ʊ ʉ ɥ ɯ v ʋ ɣ ɤ w ʍ ɯ ɰ x χ
;; y ʏ ʎ ɥ ɤ z ʒ ʑ ʐ ʔ ʕ ǀ ǁ ǃ


;; t i ʃ ə x
;; t ɤ i ʃ ə x
;; t ɤ i ʃ ɪ j
;; t ɤ i ʃ ɪ ɟ
;; ə n t ˠ i ʃ ə x

